<?php
global $wpdb;

// get 7 days view from wp_eazydocs_view_log table with sum of count column
$posts
	= $wpdb->get_results( "SELECT post_id, SUM(count) AS totalcount, created_at FROM {$wpdb->prefix}eazydocs_view_log WHERE created_at >= DATE_SUB(NOW(), INTERVAL 7 DAY) GROUP BY post_id" );

// get last month search count from wp post meta table and count total search
$last_month_views_count
	= $wpdb->get_results( "SELECT post_id, SUM(count) AS totalcount, created_at FROM {$wpdb->prefix}eazydocs_view_log WHERE created_at >= DATE_SUB(NOW(), INTERVAL 29 DAY) GROUP BY post_id" );
// check if post_views_count meta have value then plus with last_month_view_count else sum only last_month_view_count
foreach ( $last_month_views_count as $key => $value ) {
	if ( get_post_meta( $value->post_id, 'post_views_count', true ) ) {
		$last_month_views_count[ $key ]->totalcount = get_post_meta( $value->post_id, 'post_views_count', true ) + $value->totalcount;
	}
}

$labels    = [];
$dataCount = [];
$m         = date( "m" );
$de        = date( "d" );
$y         = date( "Y" );

for ( $i = 0; $i <= 6; $i ++ ) {
	$labels[]    = date( 'd M, Y', mktime( 0, 0, 0, $m, ( $de - $i ), $y ) );
	$dataCount[] = 0;
}

// Get 7 data date wise
foreach ( $posts as $key => $item ) {
	$dates = date( 'd M, Y', strtotime( $item->created_at ) );

	foreach ( $labels as $datekey => $weekdays ) {
		if ( $weekdays == $dates ) {
			if ( get_post_meta( $item->post_id, 'post_views_count', true ) ) {
				$dataCount[ $datekey ] = get_post_meta( $item->post_id, 'post_views_count', true ) + $item->totalcount;
			} else {
				$dataCount[ $datekey ] = $item->totalcount;
			}

		}
	}
}

?>
<div class="easydocs-tab tab-active" id="analytics-views">
    <h2 class="title"> Views </h2> <br>
    <div class="easydocs-filter-container">
        <ul class="single-item-filter">
            <li class="easydocs-btn easydocs-btn-blue-light easydocs-btn-rounded easydocs-btn-sm is-active" data-filter="all" onclick="ViewsLastSeveday()">
				<?php esc_html_e( 'This Week', 'eazydocs-pro' ); ?>
            </li>
            <li class="easydocs-btn easydocs-btn-orange-light easydocs-btn-rounded easydocs-btn-sm" data-filter=".protected" onclick="ViewLastMonth()">
				<?php esc_html_e( 'Last 30 Days', 'eazydocs-pro' ); ?>
            </li>
            <li class="easydocs-btn easydocs-btn-gray-light easydocs-btn-rounded easydocs-btn-sm date__range_view" data-filter=".draft">
				<?php esc_html_e( 'Custom Date Range', 'eazydocs-pro' ); ?>
            </li>
        </ul>
    </div>
    <div class="easydocs-accordion sortabled dd accordionjs nestables-child" id="nestable-9">
        <div id="OverviewViewsChart"></div>
        <div class="eazydocc-chartsummery">
            <!-- Make 3 Cards  -->
            <div class="eazy-docs-row">
                <div class="easydocs-card easy-docs-card-bg-light">
                    <div class="easydocs-card-body">
                        <div class="easydocs-card-title last-sevedays-view-chart t-success">
						    <?php echo eazydocspro_number_format( json_encode( array_sum( $dataCount ) ) ); ?>
                        </div>
                        <div class="easydocs-card-value"> <?php esc_html_e( 'This Week Views', 'eazydocs-pro' ); ?> </div>
                    </div>
                </div>
                <div class="easydocs-card easy-docs-card-bg-light">
                    <div class="easydocs-card-body">
                        <div class="easydocs-card-title last-lastmonth-view-chart t-success">
						    <?php echo eazydocspro_number_format( array_sum( array_column( $last_month_views_count, 'totalcount' ) ) ); ?>
                        </div>
                        <div class="easydocs-card-value"> <?php esc_html_e( 'Last Month Views', 'eazydocs-pro' ); ?> </div>
                    </div>
                </div>
                <div class="easydocs-card easy-docs-card-bg-light">
                    <div class="easydocs-card-body">
                        <div class="easydocs-card-title last-lastmonth-view-chart t-success">
						    <?php echo eazydocspro_number_format( ezdpro_get_total_views() ); ?>
                        </div>
                        <div class="easydocs-card-value"> <?php esc_html_e( 'Total Views', 'eazydocs-pro' ); ?> </div>
                    </div>
                </div>
            </div>

        </div>
    </div>
</div>


<script>

    // Fetch apexchartjs area chart in #OvervIewChart
    var options = {
        chart: {
            height: 450,
            type: 'area',
        },
        dataLabels: {
            enabled: false
        },
        series: [
            {
                name: "Views",
                data: <?php echo json_encode( $dataCount ); ?>
            }

        ],
        fill: {
            type: "gradient",
            gradient: {
                shadeIntensity: 1,
                opacityFrom: 0.7,
                opacityTo: 0.9,
                stops: [0, 90, 100]
            }
        },
        stroke: {
            curve: 'smooth'
        },
        xaxis: {
            categories: <?php echo json_encode( $labels ); ?>,
        },
        tooltip: {
            // x: {
            //     format: 'dd/MM/yy HH:mm'
            // },
        },
    };

    var OverviewViewchart = new ApexCharts(document.querySelector("#OverviewViewsChart"), options);
    OverviewViewchart.render();

    function ViewsLastSeveday() {
        OverviewViewchart.updateOptions({
            xaxis: {
                categories: <?php echo json_encode( $labels ); ?>,
            },
            series: [{
                name: 'Views',
                data: <?php echo json_encode( $dataCount ); ?>
            }],
        });
    }

    function ViewLastMonth() {
		<?php
		// Get last month views from wp eazy_docs_view table
		$posts
			= $wpdb->get_results( "SELECT post_id, SUM(count) AS totalcount, created_at FROM {$wpdb->prefix}eazydocs_view_log WHERE created_at >= DATE_SUB(NOW(), INTERVAL 29 DAY) GROUP BY post_id" );

		$last_month_views_count
			= $wpdb->get_results( "SELECT post_id, SUM(count) AS totalcount, created_at FROM {$wpdb->prefix}eazydocs_view_log WHERE created_at >= DATE_SUB(NOW(), INTERVAL 29 DAY) GROUP BY post_id" );
		// check if post_views_count meta have value then plus with last_month_view_count else sum only last_month_view_count
		foreach ( $last_month_views_count as $key => $value ) {
			if ( get_post_meta( $value->post_id, 'post_views_count', true ) ) {
				$last_month_views_count[ $key ]->totalcount = get_post_meta( $value->post_id, 'post_views_count', true ) + $value->totalcount;
			} else {
				$last_month_views_count[ $key ]->totalcount = $value->totalcount;
			}
		}

		$labels = [];
		$dataCount = [];

		$m = date( "m" );
		$de = date( "d" );
		$y = date( "Y" );

		for ( $i = 0; $i <= 29; $i ++ ) {
			$labels[]    = date( 'd M, Y', mktime( 0, 0, 0, $m, ( $de - $i ), $y ) );
			$dataCount[] = 0;
		}

		// Get 7 data date wise
		foreach ( $posts as $key => $item ) {
			$dates = date( 'd M, Y', strtotime( $item->created_at ) );

			foreach ( $labels as $datekey => $weekdays ) {
				if ( $weekdays == $dates ) {
					if ( get_post_meta( $item->post_id, 'post_views_count', true ) ) {
						$dataCount[ $datekey ] = get_post_meta( $item->post_id, 'post_views_count', true ) + $item->totalcount;
					} else {
						$dataCount[ $datekey ] = $item->totalcount;
					}
				}
			}

		}

		?>
        OverviewViewchart.updateOptions({
            xaxis: {
                categories: <?php echo json_encode( $labels ); ?>,
            },
            series: [{
                name: 'Views',
                data: <?php echo json_encode( $dataCount ); ?>
            }],
        });

        var last_lastmonth_view_chart = document.querySelector(".last-lastmonth-view-chart");
        last_lastmonth_view_chart.innerHTML = <?php echo array_sum( array_column( $last_month_views_count, 'totalcount' ) ); ?>;

    }

    function ViewDateRange() {
        // add daterange picker in view_date_range_data
        jQuery('.date__range_view').daterangepicker().on('apply.daterangepicker', function (e, picker) {
            var start_date = picker.startDate.format('Y-M-D');
            var end_date = picker.endDate.format('Y-M-D');

            var data = {
                'action': 'view_date_range_data',
                'start_date': start_date,
                'end_date': end_date
            };
            jQuery.post(ajaxurl, data, function (response) {
                // var obj = response.data;
                // console.log(obj);
                OverviewViewchart.updateOptions({
                    xaxis: {
                        categories: response.data.labels,
                    },
                    series: [{
                        name: 'Views',
                        data: response.data.views
                    }],
                });
            });
        });

    }

    ViewDateRange();
</script>