<?php
namespace EazyDocsPro\Frontend;

/**
* Class Frontend_Actions
 * @package EazyDocsPro\Frontend
 */
class Frontend_Actions {
	function __construct(){
		add_action('before_docs_column_wrapper', [ $this, 'before_docs_column' ], 99, 1);
		add_action( 'eazydocs_masonry_wrap', [ $this, 'eazydocs_masonry_wrap' ] );
		add_action( 'eazydocs_fronted_submission', [ $this, 'eazydocs_fronted_submission' ], 99, 2 );
		add_action( 'eazydocs_fronted_editing', [ $this, 'eazydocs_fronted_editing' ] );
	}
    
	/**
     * Docs archive page column
	 *
	 * @param $col
	 */
	public function before_docs_column($col){ ?>
		<div class="col-lg-<?php echo $col; ?>">
	<?php }

	/**
	 * Masonry wrapper for docs column
	 */
	public function eazydocs_masonry_wrap($masonry){
	    if ( $masonry == 'masonry'){ ?>
            data-masonry='{"percentPosition": true }'
	<?php }
    }
    
    /**
     *  Doc Frontend Editing
     */
    public function eazydocs_fronted_editing($edit_url){
        $frontend_edit          = ezd_get_opt('frontend_edit_switcher') ?? '';
        $doc_edit_btn_text      = ezd_get_opt('frontend_edit_btn_text') ?? esc_html__('Edit', 'eazydocs-pro');

        if ( $frontend_edit == 1 ) {
            echo '<a href="'.$edit_url.'" class="secondary-btn"><i class="icon_pencil-edit"></i> '. $doc_edit_btn_text. '</a>';
        }
    }

    /**
     *  Doc Frontend submission
     */
    public function eazydocs_fronted_submission($new_doc, $parent_doc){
        $frontend_add           = ezd_get_opt('frontend_add_switcher') ?? '';
        $doc_add_btn_text       = ezd_get_opt('frontend_add_btn_text') ?? esc_html__('Add Doc', 'eazydocs-pro');

        if ( $frontend_add == 1 ) {
            echo '<a href="'.$new_doc.'&ezd_doc_parent='.$parent_doc.'" class="add"><i class="icon_plus_alt2"></i> '. $doc_add_btn_text. '</a>';
        }
    }
}
// end